
/*  A Bison parser, made from ../src/builtin-func.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	TOK_LPP	257
#define	TOK_RPP	258
#define	TOK_LPB	259
#define	TOK_RPB	260
#define	TOK_LPPB	261
#define	TOK_RPPB	262
#define	TOK_VAR_ARG	263
#define	TOK_BOOL	264
#define	TOK_FUNCTION	265
#define	TOK_REWRITER	266
#define	TOK_EVENT	267
#define	TOK_CONST	268
#define	TOK_ENUM	269
#define	TOK_DECLARE	270
#define	TOK_WRITE	271
#define	TOK_PUSH	272
#define	TOK_EOF	273
#define	TOK_TRACE	274
#define	TOK_ARGS	275
#define	TOK_ARG	276
#define	TOK_ARGC	277
#define	TOK_ID	278
#define	TOK_ATTR	279
#define	TOK_CSTR	280
#define	TOK_LF	281
#define	TOK_WS	282
#define	TOK_COMMENT	283
#define	TOK_ATOM	284
#define	TOK_C_TOKEN	285

#line 1 "../src/builtin-func.y"

#include <vector>
#include <set>
#include <string>
#include <cstring>

using namespace std;

#include <stdio.h>
#include <stdlib.h>

extern int line_number;
extern char* input_filename;

#define print_line_directive(fp) fprintf(fp, "\n#line %d \"%s\"\n", line_number, input_filename)

extern FILE* fp_bro_init;
extern FILE* fp_func_def;
extern FILE* fp_func_h;
extern FILE* fp_func_init;
extern FILE* fp_netvar_h;
extern FILE* fp_netvar_def;
extern FILE* fp_netvar_init;

int in_c_code = 0;
int definition_type;
const char* bro_prefix;
const char* c_prefix;

enum {
	C_SEGMENT_DEF,
	FUNC_DEF,
	REWRITER_DEF,
	EVENT_DEF,
};

void set_definition_type(int type)
	{
	definition_type = type;
	switch ( type ) {
	case FUNC_DEF:
		bro_prefix = "";
		c_prefix = "bro_";
		break;

	case REWRITER_DEF:
		bro_prefix = "rewrite_";
		c_prefix = "bro_rewrite_";
		break;

	case EVENT_DEF:
		bro_prefix = "";
		c_prefix = "bro_event_";
		break;

	case C_SEGMENT_DEF:
		break;
	}
	}

const char* arg_list_name = "BiF_ARGS";
const char* trace_rewriter_name = "trace_rewriter";

#include "bif_arg.h"

extern const char* decl_name;
int var_arg; // whether the number of arguments is variable
std::vector<BuiltinFuncArg*> args;

// enum types declared by "declare enum <id>"
set<string> enum_types;

extern int yyerror(const char[]);
extern int yywarn(const char msg[]);
extern int yylex();

char* concat(const char* str1, const char* str2)
	{
	int len1 = strlen(str1);
	int len2 = strlen(str2);

	char* s = new char[len1 + len2 +1];

	memcpy(s, str1, len1);
	memcpy(s + len1, str2, len2);

	s[len1+len2] = '\0';

	return s;
	}

// Print the bro_event_* function prototype in C++, without the ending ';'
void print_event_c_prototype(FILE *fp)
	{
	fprintf(fp, "void %s%s(Analyzer* analyzer%s", c_prefix, decl_name,
			args.size() ? ", " : "" );
	for ( int i = 0; i < (int) args.size(); ++i )
		{
		if ( i > 0 )
			fprintf(fp, ", ");
		args[i]->PrintCArg(fp, i);
		}
	fprintf(fp, ")");
	}

// Print the bro_event_* function body in C++.
void print_event_c_body(FILE *fp)
	{
	fprintf(fp, "\t{\n");
	fprintf(fp, "\t// Note that it is intentional that here we do not\n");
	fprintf(fp, "\t// check if %s is NULL, which should happen *before*\n",
		decl_name);
	fprintf(fp, "\t// bro_event_%s is called to avoid unnecessary Val\n",
		decl_name);
	fprintf(fp, "\t// allocation.\n");
	fprintf(fp, "\n");

	fprintf(fp, "\tval_list* vl = new val_list;\n\n");
	BuiltinFuncArg *connection_arg = 0;

	for ( int i = 0; i < (int) args.size(); ++i )
		{
		fprintf(fp, "\t");
		fprintf(fp, "vl->append(");
		args[i]->PrintBroValConstructor(fp);
		fprintf(fp, ");\n");

		if ( args[i]->Type() == TYPE_CONNECTION )
			{
			if ( connection_arg == 0 )
				connection_arg = args[i];
			else
				{
				// We are seeing two connection type arguments.
				yywarn("Warning: with more than connection-type "
				       "event arguments, bifcl only passes "
				       "the first one to EventMgr as cookie.");
				}
			}
		}

	fprintf(fp, "\n");
	fprintf(fp, "\tmgr.QueueEvent(%s, vl, SOURCE_LOCAL, analyzer->GetID(), timer_mgr",
		decl_name);

	if ( connection_arg )
		// Pass the connection to the EventMgr as the "cookie"
		fprintf(fp, ", %s", connection_arg->Name());

	fprintf(fp, ");\n");
	fprintf(fp, "\t} // event generation\n");
	}

#line 168 "../src/builtin-func.y"
typedef union	{
	char* str;
	int val;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		129
#define	YYFLAG		-32768
#define	YYNTBASE	36

#define YYTRANSLATE(x) ((unsigned)(x) <= 285 ? yytranslate[x] : 73)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,    32,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    33,    34,     2,
    35,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     6,     8,    10,    12,    14,    16,    18,    20,
    28,    35,    41,    47,    51,    58,    64,    65,    70,    75,
    76,    78,    83,    88,    89,    90,    96,    98,   100,   102,
   103,   106,   111,   115,   117,   119,   121,   123,   129,   133,
   139,   141,   146,   150,   151,   152,   155,   158,   164,   166,
   170,   172,   174,   176,   178,   180,   182,   184,   186,   188,
   190,   192,   195,   198,   201
};

static const short yyrhs[] = {    36,
    37,    72,     0,    72,     0,    39,     0,    40,     0,    41,
     0,    69,     0,    42,     0,    45,     0,    38,     0,    16,
    72,    15,    72,    24,    72,    34,     0,    53,    72,    56,
    49,    54,    34,     0,    51,    72,    55,    54,    64,     0,
    52,    72,    56,    54,    64,     0,    43,    44,     6,     0,
    15,    72,    24,    72,     5,    72,     0,    44,    24,    72,
    32,    72,     0,     0,    46,    48,    49,    34,     0,    14,
    72,    24,    72,     0,     0,    48,     0,    35,    72,    10,
    72,     0,    35,    72,    26,    72,     0,     0,     0,    49,
    25,    50,    72,    47,     0,    11,     0,    12,     0,    13,
     0,     0,    56,    63,     0,    57,    60,    59,    72,     0,
    24,    72,    58,     0,     3,     0,     4,     0,    61,     0,
    72,     0,    61,    32,    72,    62,    72,     0,    72,    62,
    72,     0,    24,    72,    33,    72,    24,     0,     9,     0,
    33,    72,    24,    72,     0,    67,    70,    68,     0,     0,
     0,     5,    65,     0,     6,    66,     0,     7,    65,    70,
    66,     8,     0,    72,     0,    70,    71,    72,     0,    24,
     0,    31,     0,    22,     0,    21,     0,    23,     0,    20,
     0,    17,     0,    18,     0,    19,     0,    26,     0,    30,
     0,    72,    28,     0,    72,    27,     0,    72,    29,     0,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   175,   177,   198,   199,   200,   201,   202,   203,   204,   207,
   213,   223,   226,   229,   246,   255,   260,   263,   273,   281,
   282,   286,   290,   294,   295,   296,   299,   303,   307,   311,
   317,   322,   346,   402,   406,   409,   410,   414,   415,   419,
   421,   429,   438,   445,   452,   456,   507,   515,   518,   520,
   524,   526,   528,   530,   532,   534,   536,   538,   540,   542,
   544,   548,   550,   552,   559
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","TOK_LPP",
"TOK_RPP","TOK_LPB","TOK_RPB","TOK_LPPB","TOK_RPPB","TOK_VAR_ARG","TOK_BOOL",
"TOK_FUNCTION","TOK_REWRITER","TOK_EVENT","TOK_CONST","TOK_ENUM","TOK_DECLARE",
"TOK_WRITE","TOK_PUSH","TOK_EOF","TOK_TRACE","TOK_ARGS","TOK_ARG","TOK_ARGC",
"TOK_ID","TOK_ATTR","TOK_CSTR","TOK_LF","TOK_WS","TOK_COMMENT","TOK_ATOM","TOK_C_TOKEN",
"','","':'","';'","'='","definitions","definition","declare_def","event_def",
"func_def","rewriter_def","enum_def","enum_def_1","enum_list","const_def","const_def_1",
"opt_const_init","const_init","opt_attr","@1","func_prefix","rewriter_prefix",
"event_prefix","end_of_head","typed_head","plain_head","head_1","arg_begin",
"arg_end","args","args_1","arg","return_type","body","c_code_begin","c_code_end",
"body_start","body_end","c_code_segment","c_body","c_atom","opt_ws", NULL
};
#endif

static const short yyr1[] = {     0,
    36,    36,    37,    37,    37,    37,    37,    37,    37,    38,
    39,    40,    41,    42,    43,    44,    44,    45,    46,    47,
    47,    48,    48,    49,    50,    49,    51,    52,    53,    54,
    55,    56,    57,    58,    59,    60,    60,    61,    61,    62,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    70,
    71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
    71,    72,    72,    72,    72
};

static const short yyr2[] = {     0,
     3,     1,     1,     1,     1,     1,     1,     1,     1,     7,
     6,     5,     5,     3,     6,     5,     0,     4,     4,     0,
     1,     4,     4,     0,     0,     5,     1,     1,     1,     0,
     2,     4,     3,     1,     1,     1,     1,     5,     3,     5,
     1,     4,     3,     0,     0,     2,     2,     5,     1,     3,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     2,     2,     2,     0
};

static const short yydefact[] = {    65,
     0,     2,    44,    27,    28,    29,    65,    65,    65,    65,
     9,     3,     4,     5,     7,    17,     8,     0,    65,    65,
    65,     6,    63,    62,    64,    65,     0,     0,     0,     1,
     0,    65,    24,     0,     0,     0,    45,    49,    65,    65,
    65,    14,    65,     0,     0,    65,    30,     0,    65,    30,
    24,    57,    58,    59,    56,    54,    53,    55,    51,    60,
    61,    52,     0,    65,    19,     0,     0,     0,    65,    65,
    25,    18,     0,     0,    65,    31,     0,    36,    37,     0,
    30,    48,    50,    65,    65,    65,    22,    23,    65,    34,
    33,    44,    12,    65,     0,    35,    65,    65,    41,    65,
    65,    13,     0,    15,     0,    16,    20,    46,     0,    65,
    32,     0,     0,    39,    11,    10,    26,    21,    45,    43,
    42,    65,    65,    47,    38,     0,    40,     0,     0
};

static const short yydefgoto[] = {     1,
    10,    11,    12,    13,    14,    15,    16,    31,    17,    18,
   117,    33,    45,    89,    19,    20,    21,    74,    47,    48,
    49,    91,    97,    77,    78,   101,    76,    93,    26,    63,
    94,   120,    22,    37,    64,    38
};

static const short yypact[] = {-32768,
    92,   133,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -31,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    44,   106,    23,   133,
    -1,-32768,-32768,   112,   112,   112,    94,   133,-32768,-32768,
-32768,-32768,-32768,    51,   -22,-32768,-32768,   -16,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,     3,-32768,   133,     1,   118,   -14,-32768,-32768,
-32768,-32768,    -2,    17,-32768,-32768,    20,     5,     7,    17,
    22,-32768,   133,-32768,-32768,-32768,   133,   133,-32768,-32768,
-32768,-32768,-32768,-32768,   124,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    14,   133,    54,   133,    67,-32768,    36,-32768,
   133,     7,    99,   133,-32768,-32768,-32768,-32768,-32768,-32768,
   133,-32768,-32768,-32768,   133,   130,-32768,    63,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   -42,    25,-32768,-32768,-32768,-32768,   -48,-32768,     9,
-32768,-32768,-32768,-32768,-32768,   -38,-32768,    10,    -5,   -28,
-32768,-32768,-32768,    15,-32768,     0
};


#define	YYLAST		162


static const short yytable[] = {     2,
    90,    80,    71,    32,    42,    84,    27,    28,    29,    30,
    82,    72,    23,    24,    25,    99,    75,    86,    34,    35,
    36,    92,    43,    96,    23,    24,    25,    23,    24,    25,
   100,    44,   103,    23,    24,    25,    98,    41,    65,    66,
    67,   119,    68,    50,    51,    73,    71,   115,    79,    23,
    24,    25,    52,    53,    54,    55,    56,    57,    58,    59,
    69,    60,   129,    83,   118,    61,    62,    39,    87,    88,
    23,    24,    25,   122,    95,    81,    70,    23,    24,    25,
    23,    24,    25,   104,   105,   106,   108,   116,   107,   102,
   124,   128,     0,    23,    24,    25,   111,   112,     3,   113,
   114,    32,     4,     5,     6,     7,     8,     9,   109,   121,
    52,    53,    54,    55,    56,    57,    58,    59,     0,    60,
     0,   125,   126,    61,    62,    23,    24,    25,     0,    40,
     0,   123,    23,    24,    25,    46,     0,     0,    23,    24,
    25,    85,     0,     0,    23,    24,    25,   110,     0,     0,
    23,    24,    25,   127,     0,     0,    23,    24,    25,    23,
    24,    25
};

static const short yycheck[] = {     0,
     3,    50,    25,    35,     6,     5,     7,     8,     9,    10,
     8,    34,    27,    28,    29,     9,    33,    32,    19,    20,
    21,     5,    24,     4,    27,    28,    29,    27,    28,    29,
    24,    32,    81,    27,    28,    29,    32,    15,    39,    40,
    41,     6,    43,    35,    36,    46,    25,    34,    49,    27,
    28,    29,    17,    18,    19,    20,    21,    22,    23,    24,
    10,    26,     0,    64,   107,    30,    31,    24,    69,    70,
    27,    28,    29,   112,    75,    51,    26,    27,    28,    29,
    27,    28,    29,    84,    85,    86,    92,    34,    89,    80,
   119,     0,    -1,    27,    28,    29,    97,    98,     7,   100,
   101,    35,    11,    12,    13,    14,    15,    16,    94,   110,
    17,    18,    19,    20,    21,    22,    23,    24,    -1,    26,
    -1,   122,   123,    30,    31,    27,    28,    29,    -1,    24,
    -1,    33,    27,    28,    29,    24,    -1,    -1,    27,    28,
    29,    24,    -1,    -1,    27,    28,    29,    24,    -1,    -1,
    27,    28,    29,    24,    -1,    -1,    27,    28,    29,    27,
    28,    29
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 176 "../src/builtin-func.y"
{ fprintf(fp_func_def, "%s", yyvsp[0].str); ;
    break;}
case 2:
#line 178 "../src/builtin-func.y"
{
			int n = 1024 + strlen(input_filename);
			char auto_gen_comment[n];

			snprintf(auto_gen_comment, n,
				"This file was automatically generated by bifcl from %s.",
				input_filename);

			fprintf(fp_bro_init, "# %s\n\n", auto_gen_comment);
			fprintf(fp_func_def, "// %s\n\n", auto_gen_comment);
			fprintf(fp_func_h, "// %s\n\n", auto_gen_comment);
			fprintf(fp_func_init, "// %s\n\n", auto_gen_comment);
			fprintf(fp_netvar_def, "// %s\n\n", auto_gen_comment);
			fprintf(fp_netvar_h, "// %s\n\n", auto_gen_comment);
			fprintf(fp_netvar_init, "// %s\n\n", auto_gen_comment);

			fprintf(fp_func_def, "%s", yyvsp[0].str);
			;
    break;}
case 10:
#line 208 "../src/builtin-func.y"
{
			enum_types.insert(yyvsp[-2].str);
			;
    break;}
case 11:
#line 214 "../src/builtin-func.y"
{
			print_event_c_prototype(fp_func_h);
			fprintf(fp_func_h, ";\n");
			print_event_c_prototype(fp_func_def);
			fprintf(fp_func_def, "\n");
			print_event_c_body(fp_func_def);
			;
    break;}
case 14:
#line 230 "../src/builtin-func.y"
{
			// First, put an end to the enum type decl.
			fprintf(fp_bro_init, "};\n");
			fprintf(fp_netvar_h, "}; }\n");

			// Now generate the netvar's.
			fprintf(fp_netvar_h,
				"extern EnumType* enum_%s;\n", decl_name);
			fprintf(fp_netvar_def,
				"EnumType* enum_%s;\n", decl_name);
			fprintf(fp_netvar_init,
				"\tenum_%s = internal_type(\"%s\")->AsEnumType();\n",
				decl_name, decl_name);
			;
    break;}
case 15:
#line 247 "../src/builtin-func.y"
{
			decl_name = yyvsp[-3].str;
			fprintf(fp_bro_init, "type %s: enum %s{%s", yyvsp[-3].str, yyvsp[-2].str, yyvsp[0].str);
			fprintf(fp_netvar_h, "namespace BroEnum { ");
			fprintf(fp_netvar_h, "enum %s {\n", yyvsp[-3].str);
			;
    break;}
case 16:
#line 256 "../src/builtin-func.y"
{
			fprintf(fp_bro_init, "%s%s,%s", yyvsp[-3].str, yyvsp[-2].str, yyvsp[0].str);
			fprintf(fp_netvar_h, "\t%s,\n", yyvsp[-3].str);
			;
    break;}
case 18:
#line 264 "../src/builtin-func.y"
{
			fprintf(fp_bro_init, ";\n");
			fprintf(fp_netvar_h, "extern int %s;\n", decl_name);
			fprintf(fp_netvar_def, "int %s;\n", decl_name);
			fprintf(fp_netvar_init, "\t%s = internal_val(\"%s\")->AsBool();\n",
				decl_name, decl_name);
			;
    break;}
case 19:
#line 274 "../src/builtin-func.y"
{
			decl_name = yyvsp[-1].str;
			fprintf(fp_bro_init, "const%s", yyvsp[-2].str);
			fprintf(fp_bro_init, "%s: bool%s", yyvsp[-1].str, yyvsp[0].str);
			;
    break;}
case 22:
#line 287 "../src/builtin-func.y"
{
			fprintf(fp_bro_init, "=%s%c%s", yyvsp[-2].str, (yyvsp[-1].val) ? 'T' : 'F', yyvsp[0].str);
			;
    break;}
case 23:
#line 291 "../src/builtin-func.y"
{ fprintf(fp_bro_init, "=%s%s%s", yyvsp[-2].str, yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 25:
#line 295 "../src/builtin-func.y"
{ fprintf(fp_bro_init, "%s", yyvsp[0].str); ;
    break;}
case 27:
#line 300 "../src/builtin-func.y"
{ set_definition_type(FUNC_DEF); ;
    break;}
case 28:
#line 304 "../src/builtin-func.y"
{ set_definition_type(REWRITER_DEF); ;
    break;}
case 29:
#line 308 "../src/builtin-func.y"
{ set_definition_type(EVENT_DEF); ;
    break;}
case 30:
#line 312 "../src/builtin-func.y"
{
			fprintf(fp_bro_init, ";\n");
			;
    break;}
case 31:
#line 318 "../src/builtin-func.y"
{
			;
    break;}
case 32:
#line 323 "../src/builtin-func.y"
{
			if ( var_arg )
				fprintf(fp_bro_init, "va_args: any");
			else
				{
				if ( definition_type == REWRITER_DEF )
					fprintf(fp_bro_init, "c: connection");

				for ( int i = 0; i < (int) args.size(); ++i )
					{
					if ( i > 0 || definition_type == REWRITER_DEF )
						fprintf(fp_bro_init, ", ");
					args[i]->PrintBro(fp_bro_init);
					}
				}

			fprintf(fp_bro_init, ")");

			fprintf(fp_bro_init, "%s", yyvsp[0].str);
			fprintf(fp_func_def, "%s", yyvsp[0].str);
			;
    break;}
case 33:
#line 347 "../src/builtin-func.y"
{
			const char* method_type = 0;
			decl_name = yyvsp[-2].str;

			if ( definition_type == FUNC_DEF || definition_type == REWRITER_DEF )
				{
				method_type = "function";
				print_line_directive(fp_func_def);
				}
			else if ( definition_type == EVENT_DEF )
				method_type = "event";

			if ( method_type )
				fprintf(fp_bro_init,
					"global %s%s: %s%s(",
					bro_prefix, decl_name, method_type, yyvsp[-1].str);

			if ( definition_type == FUNC_DEF || definition_type == REWRITER_DEF )
				{
				fprintf(fp_func_init,
					"\textern Val* %s%s(Frame* frame, val_list*);\n",
					c_prefix, decl_name);

				fprintf(fp_func_init,
					"\t(void) new BuiltinFunc(%s%s, \"%s%s\", 0);\n",
					c_prefix, decl_name, bro_prefix, decl_name);

				fprintf(fp_func_h,
					"extern Val* %s%s(Frame* frame, val_list*);\n",
					c_prefix, decl_name);

				fprintf(fp_func_def,
					"Val* %s%s(Frame* frame, val_list* %s)",
					c_prefix, decl_name, arg_list_name);
				}
			else if ( definition_type == EVENT_DEF )
				{
				fprintf(fp_netvar_h,
					"extern EventHandlerPtr %s;\n",
					decl_name);

				fprintf(fp_netvar_def,
					"EventHandlerPtr %s;\n",
					decl_name);

				fprintf(fp_netvar_init,
					"\t%s = internal_handler(\"%s\");\n",
					decl_name, decl_name);

				// C++ prototypes of bro_event_* functions will
				// be generated later.
				}
			;
    break;}
case 34:
#line 403 "../src/builtin-func.y"
{ args.clear(); var_arg = 0; ;
    break;}
case 37:
#line 411 "../src/builtin-func.y"
{ /* empty, to avoid yacc complaint about type clash */ ;
    break;}
case 39:
#line 416 "../src/builtin-func.y"
{ /* empty */ ;
    break;}
case 40:
#line 420 "../src/builtin-func.y"
{ args.push_back(new BuiltinFuncArg(yyvsp[-4].str, yyvsp[0].str)); ;
    break;}
case 41:
#line 422 "../src/builtin-func.y"
{
			if ( definition_type == EVENT_DEF )
				yyerror("events cannot have variable arguments");
			var_arg = 1;
			;
    break;}
case 42:
#line 430 "../src/builtin-func.y"
{
			BuiltinFuncArg* ret = new BuiltinFuncArg("", yyvsp[-1].str);
			ret->PrintBro(fp_bro_init);
			delete ret;
			fprintf(fp_func_def, "%s", yyvsp[0].str);
			;
    break;}
case 43:
#line 439 "../src/builtin-func.y"
{
			fprintf(fp_func_def, " // end of %s\n", decl_name);
			print_line_directive(fp_func_def);
			;
    break;}
case 44:
#line 446 "../src/builtin-func.y"
{
			in_c_code = 1;
			print_line_directive(fp_func_def);
			;
    break;}
case 45:
#line 453 "../src/builtin-func.y"
{ in_c_code = 0; ;
    break;}
case 46:
#line 457 "../src/builtin-func.y"
{
			int implicit_arg = 0;
			int argc = args.size();

			fprintf(fp_func_def, "{");
			if ( definition_type == REWRITER_DEF )
				{
				implicit_arg = 1;
				++argc;
				}

			if ( argc > 0 || ! var_arg )
				fprintf(fp_func_def, "\n");

			if ( ! var_arg )
				{
				fprintf(fp_func_def, "\tif ( %s->length() != %d )\n", arg_list_name, argc);
				fprintf(fp_func_def, "\t\t{\n");
				fprintf(fp_func_def,
					"\t\trun_time(\"%s() takes exactly %d argument(s)\");\n",
					decl_name, argc);
				fprintf(fp_func_def, "\t\treturn 0;\n");
				fprintf(fp_func_def, "\t\t}\n");
				}
			else if ( argc > 0 )
				{
				fprintf(fp_func_def, "\tif ( %s->length() < %d )\n", arg_list_name, argc);
				fprintf(fp_func_def, "\t\t{\n");
				fprintf(fp_func_def,
					"\t\trun_time(\"%s() takes at least %d argument(s)\");\n",
					decl_name, argc);
				fprintf(fp_func_def, "\t\treturn 0;\n");
				fprintf(fp_func_def, "\t\t}\n");
				}

			if ( definition_type == REWRITER_DEF )
				{
				fprintf(fp_func_def,
					"\tRewriter* %s = get_trace_rewriter((*%s)[0]);\n",
					trace_rewriter_name,
					arg_list_name);
				fprintf(fp_func_def, "\tif ( ! trace_rewriter )\n");
				fprintf(fp_func_def, "\t\treturn 0;\n");
				}
			for ( int i = 0; i < (int) args.size(); ++i )
				args[i]->PrintCDef(fp_func_def, i + implicit_arg);
			print_line_directive(fp_func_def);
			;
    break;}
case 47:
#line 508 "../src/builtin-func.y"
{
			if ( definition_type == REWRITER_DEF )
				fprintf(fp_func_def, "\n\treturn 0;\n");
			fprintf(fp_func_def, "}");
			;
    break;}
case 49:
#line 519 "../src/builtin-func.y"
{ fprintf(fp_func_def, "%s", yyvsp[0].str); ;
    break;}
case 50:
#line 521 "../src/builtin-func.y"
{ fprintf(fp_func_def, "%s", yyvsp[0].str); ;
    break;}
case 51:
#line 525 "../src/builtin-func.y"
{ fprintf(fp_func_def, "%s", yyvsp[0].str); ;
    break;}
case 52:
#line 527 "../src/builtin-func.y"
{ fprintf(fp_func_def, "%s", yyvsp[0].str); ;
    break;}
case 53:
#line 529 "../src/builtin-func.y"
{ fprintf(fp_func_def, "(*%s)", arg_list_name); ;
    break;}
case 54:
#line 531 "../src/builtin-func.y"
{ fprintf(fp_func_def, "%s", arg_list_name); ;
    break;}
case 55:
#line 533 "../src/builtin-func.y"
{ fprintf(fp_func_def, "%s->length()", arg_list_name); ;
    break;}
case 56:
#line 535 "../src/builtin-func.y"
{ fprintf(fp_func_def, "%s", trace_rewriter_name); ;
    break;}
case 57:
#line 537 "../src/builtin-func.y"
{ fprintf(fp_func_def, "%s->WriteData", trace_rewriter_name); ;
    break;}
case 58:
#line 539 "../src/builtin-func.y"
{ fprintf(fp_func_def, "%s->Push", trace_rewriter_name); ;
    break;}
case 59:
#line 541 "../src/builtin-func.y"
{ fprintf(fp_func_def, "%s->EndOfData", trace_rewriter_name); ;
    break;}
case 60:
#line 543 "../src/builtin-func.y"
{ fprintf(fp_func_def, "%s", yyvsp[0].str); ;
    break;}
case 61:
#line 545 "../src/builtin-func.y"
{ fprintf(fp_func_def, "%c", yyvsp[0].val); ;
    break;}
case 62:
#line 549 "../src/builtin-func.y"
{ yyval.str = concat(yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 63:
#line 551 "../src/builtin-func.y"
{ yyval.str = concat(yyvsp[-1].str, "\n"); ;
    break;}
case 64:
#line 553 "../src/builtin-func.y"
{
			if ( in_c_code )
				yyval.str = concat(yyvsp[-1].str, yyvsp[0].str);
			else
				yyval.str = yyvsp[-1].str;
			;
    break;}
case 65:
#line 560 "../src/builtin-func.y"
{ yyval.str = ""; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 563 "../src/builtin-func.y"


extern char* yytext;
extern char* input_filename;
extern int line_number;
const char* decl_name;

void print_msg(const char msg[])
	{
	int msg_len = strlen(msg) + strlen(yytext) + 64;
	char* msgbuf = new char[msg_len];

	if ( yytext[0] == '\n' )
		snprintf(msgbuf, msg_len, "%s, on previous line", msg);

	else if ( yytext[0] == '\0' )
		snprintf(msgbuf, msg_len, "%s, at end of file", msg);

	else
		snprintf(msgbuf, msg_len, "%s, at or near \"%s\"", msg, yytext);

	/*
	extern int column;
	sprintf(msgbuf, "%*s\n%*s\n", column, "^", column, msg);
	*/

	if ( input_filename )
		fprintf(stderr, "%s:%d: ", input_filename, line_number);
	else
		fprintf(stderr, "line %d: ", line_number);
	fprintf(stderr, "%s\n", msgbuf);

	delete [] msgbuf;
	}

int yywarn(const char msg[])
	{
	print_msg(msg);
	return 0;
	}

int yyerror(const char msg[])
	{
	print_msg(msg);

	abort();
	exit(1);
	return 0;
	}
